﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGInt64FieldXNE
{
    class ViewModel : INotifyPropertyChanged
    {
        private DataUtil _dataUtil;

        public ViewModel()
        {
            this.DataUtilInstance = new DataUtil();
        }

        public DataUtil DataUtilInstance
        {
            get
            {
                return this._dataUtil;
            }
            set
            {
                if (this._dataUtil != value)
                {
                    this._dataUtil = value;
                    OnPropertyChanged("DataUtilInstance");
                }
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class DataUtil
    {
        #region private members

        #region private fields

        private static ObservableCollection<Item> items;

        #endregion

        #region private methods


        private static ObservableCollection<Item> CreateProducts()
        {
            return new ObservableCollection<Item>
            {
                 
                new Item
                {
                    ItemID = 1,
                    ItemName = "Item1",
                    UnitPrice = Int64.MaxValue,
                },

                new Item
                {
                    ItemID = 2,
                    ItemName = "Item2",
                    UnitPrice = Int32.MaxValue,
                },

                new Item
                {
                    ItemID = 3,
                    ItemName = "Item3",
                    UnitPrice = Int64.MinValue,
                },

            };
        }



        #endregion

        #endregion

        #region public members

        #region public properties


        public static ObservableCollection<Item> Items
        {
            get
            {
                if (items == null)
                    items = CreateProducts();

                return items;
            }
        }


        #endregion

        #endregion
    }

    public class Item : INotifyPropertyChanged
    {

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion

        #region private members

        private int itemID;
        private string itemName;
        private Int64 itemQuantity;

        #endregion

        #region public properties

        public int ItemID
        {
            get
            {
                return this.itemID;
            }
            set
            {
                if (this.itemID != value)
                {
                    this.itemID = value;
                    OnPropertyChanged("ItemID");
                }
            }
        }

        public string ItemName
        {
            get
            {
                return this.itemName;
            }
            set
            {
                if (this.itemName != value)
                {
                    this.itemName = value;
                    OnPropertyChanged("ItemName");
                }
            }
        }

        public Int64 UnitPrice
        {
            get
            {
                return this.itemQuantity;
            }
            set
            {
                this.itemQuantity = value;
                OnPropertyChanged("ItemQuantity");
            }
        }

        #endregion
    }
}
